﻿// --------------------------------
// <copyright file="CameraOrbit.cs" company="COMPANY">
//     Copyright (C) COMPANY.  All rights reserved.
// </copyright>
// --------------------------------

using UnityEngine;

/// <summary>
/// CameraOrbit class.
/// </summary>
[RequireComponent(typeof(Camera))]
public class CameraOrbit : MonoBehaviour
{
    /// <summary>
    /// Focus point.
    /// </summary>
	public Vector3 lookAt;

	public float strength = 1f;
	
	public bool isActive = false;

	//private Camera myCamera;

	private Vector3 truePosition;

	/// <summary>
	/// Initialize script state.
	/// </summary>
	internal void Start()
	{
		//this.myCamera = this.GetComponent<Camera>();
		this.truePosition = this.transform.position;
	}

    /// <summary>
    /// Update script, called once per frame.
    /// </summary>
    internal void Update()
    {
		this.transform.LookAt(this.lookAt);
    }

	/// <summary>
	/// Update script, called on a fixed interval.
	/// </summary>
	internal void FixedUpdate()
	{
		// update true position
		this.transform.position = this.truePosition;
		this.transform.RotateAround(this.lookAt, Vector3.up, -0.1f);
		this.truePosition = this.transform.position;

		// shake (if active)
		if (this.isActive)
		{
			this.transform.position = this.truePosition + (Random.insideUnitSphere * this.strength);
		}
	}
}