// --------------------------------
// <copyright file="CameraShake.cs" company="COMPANY">
//     Copyright (C) COMPANY.  All rights reserved.
// </copyright>
// --------------------------------

using System.Collections;
using UnityEngine;

/// <summary>
/// CameraShake class.
/// </summary>
public class CameraShake : MonoBehaviour
{
	public float duration = 1f;

	/// <summary>
	/// Initialize script state.
	/// </summary>
	internal void Start()
	{
		// shake camera
		var cam = FindObjectOfType<CameraOrbit>();
		if (cam)
		{
			cam.isActive = true;
		}

		this.StartCoroutine(this.Kill(this.duration));
	}

	/// <summary>
	/// Kill this after particles expire.
	/// </summary>
	/// <returns>Coroutine iterator.</returns>
	internal IEnumerator Kill(float lifespan)
	{
		yield return new WaitForSeconds(lifespan);
		
		// unshake camera
		var cam = FindObjectOfType<CameraOrbit>();
		if (cam)
		{
			cam.isActive = false;
		}
		
		Destroy(this.gameObject);
	}
}