﻿// --------------------------------
// <copyright file="CityBuilder.cs" company="COMPANY">
//     Copyright (C) COMPANY.  All rights reserved.
// </copyright>
// --------------------------------

using UnityEngine;

/// <summary>
/// CityBuilder class.
/// </summary>
[RequireComponent(typeof(PopulationManager))]
public class CityBuilder : MonoBehaviour
{
	public GameObject blockPrefab;

	public int columns = 5;
	public int rows = 5;

	public float blockSize = 2.5f;

    /// <summary>
    /// Initialize script state.
    /// </summary>
    internal void Start()
    {
		var populationManager = this.GetComponent<PopulationManager>();
		for (int x = 0; x < this.columns; x++)
		{
			for (int y = 0; y < this.rows; y++)
			{
				var block = (GameObject)Instantiate(this.blockPrefab, new Vector3(x * this.blockSize, 0f, y * this.blockSize), Quaternion.identity);
				block.transform.parent = this.transform;
				block.name = string.Format("Block ({0}, {1})", x, y);
				block.GetComponent<BlockBuilder>().populationManager = populationManager;
			}
		}
    }
}