﻿// --------------------------------
// <copyright file="DisasterSelectButton.cs" company="COMPANY">
//     Copyright (C) COMPANY.  All rights reserved.
// </copyright>
// --------------------------------

using System.Collections;
using UnityEngine;

/// <summary>
/// DisasterSelectButton class.
/// </summary>
[RequireComponent(typeof(UIToggle))]
public class DisasterSelectButton : MonoBehaviour
{
	/// <summary>
	/// The disaster manager.
	/// </summary>
	public DisasterManager disasterManager;

	/// <summary>
	/// My disaster.
	/// </summary>
	public DisasterType myDisaster;

	/// <summary>
	/// The toggle.
	/// </summary>
	private UIToggle toggle;

	/// <summary>
	/// Initialize script state.
	/// </summary>
	internal void Start()
	{
		this.toggle = this.GetComponent<UIToggle>();
		this.toggle.optionCanBeNone = true;
	}

	/// <summary>
	/// Handles a click event.
	/// </summary>
	internal void OnClick()
	{
		this.disasterManager.selectedDisaster = this.myDisaster;
	}

	/// <summary>
	/// Update script, called once per frame.
	/// </summary>
	internal void Update()
	{
		if (this.toggle.value && this.disasterManager.selectedDisaster == DisasterType.None)
		{
			this.toggle.value = false;
		}
	}
}