﻿// --------------------------------
// <copyright file="Meteor.cs" company="COMPANY">
//     Copyright (C) COMPANY.  All rights reserved.
// </copyright>
// --------------------------------

using System.Collections;
using UnityEngine;

/// <summary>
/// Meteor class.
/// </summary>
public class Meteor : MonoBehaviour
{
	public GameObject cameraShakePrefab;

	/// <summary>
	/// Called when this collider/rigidbody has begun touching another rigidbody/collider.
	/// </summary>
	/// <param name="collision">Collision details.</param>
	internal void OnCollisionEnter(Collision collision)
	{
		var particleEffectManager = FindObjectOfType<ParticleEffectManager>();
		if (particleEffectManager)
		{
			particleEffectManager.InstantiateParticles(particleEffectManager.explosionPrefab, this.transform.position);
		}

		var particles = this.GetComponentInChildren<ParticleManager>();
		if (particles)
		{
			particles.Dismiss();
		}

		Instantiate(this.cameraShakePrefab, Vector3.zero, Quaternion.identity);

		Destroy(this.gameObject);
	}
}