﻿// --------------------------------
// <copyright file="RigidbodyShaker.cs" company="COMPANY">
//     Copyright (C) COMPANY.  All rights reserved.
// </copyright>
// --------------------------------

using UnityEngine;

/// <summary>
/// RigidbodyShaker class.
/// </summary>
[RequireComponent(typeof(Rigidbody))]
public class RigidbodyShaker : MonoBehaviour
{
	public float strength = 1f;

	public bool is2d = true;

	public bool isActive = false;
	private bool wasActive;
	
	private Vector3 homePosition;
	
	/// <summary>
	/// Initialize script state.
	/// </summary>
	internal void Start()
	{
		this.homePosition = this.transform.localPosition;
	    this.wasActive = this.isActive;
	}

	/// <summary>
	/// Update script, called on a fixed interval.
	/// </summary>
	internal void FixedUpdate()
	{
		if (this.isActive)
		{
			var offset = Random.insideUnitSphere;
			if (this.is2d)
			{
				var tempOffset = Random.insideUnitCircle;
				offset = new Vector3(tempOffset.x, 0f, tempOffset.y);
			}

			this.rigidbody.MovePosition(this.homePosition + (offset * this.strength));
		}
		else if (this.wasActive)
		{
			this.rigidbody.MovePosition(this.homePosition);
		}
		
		this.wasActive = this.isActive;
	}
}